"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const error_1 = require("@pnpm/error");
const versionSelectorType = require("version-selector-type");
function getPref(alias, name, version, opts) {
    var _a;
    const prefix = alias !== name ? `npm:${name}@` : '';
    if ((_a = opts.rawSpec) === null || _a === void 0 ? void 0 : _a.startsWith(`${alias}@${prefix}`)) {
        const selector = versionSelectorType(opts.rawSpec.substr(`${alias}@${prefix}`.length));
        if (selector && (selector.type === 'version' || selector.type === 'range')) {
            return opts.rawSpec.substr(alias.length + 1);
        }
    }
    switch (opts.pinnedVersion || 'major') {
        case 'major':
            return `${prefix}^${version}`;
        case 'minor':
            return `${prefix}~${version}`;
        case 'patch':
            return `${prefix}${version}`;
        default:
            throw new error_1.default('BAD_PINNED_VERSION', `Cannot pin '${opts.pinnedVersion}'`);
    }
}
exports.default = getPref;
